// $Id: test-ticket-client-anon.C,v 1.1 2003/07/20 11:08:03 dvermeir Exp $

// Test ticketserver by sending test-request.xml to server.

#include <dvssl/sslsocket.h>
#include <dvssl/x509cert.h>
#include <dvxml/xml.h>
#include "ticket.h"

#include "xml-sndrcv.h"

int
main(int argc,char* argv[]) {

try {
  std::cout << "1) Buy new anonymous ticket" << std::endl;
  Dv::Ticket::Ticket::Ref t1(
    Dv::Ticket::Ticket::buy_anon("localhost", 1050, "dvermeir", "INFO") );
  if (! t1)
    throw std::runtime_error("cannot buy anon ticket");

  std::cout << t1->xml() << std::endl;

  if (t1->user().category() != "anonymous")
    throw std::runtime_error("t1 not anonymous");

  std::cout << "2) Validate the ticket" << std::endl;
  Dv::Ticket::Ticket::Ref t2(
    Dv::Ticket::Ticket::validate("localhost", 1050, t1->serial()) );
  if (! t2)
    throw std::runtime_error("cannot validate ticket");
  std::cout << t2->xml() << std::endl;

  std::cout << "3) Try to validate invalid serial #" << std::endl;
  Dv::Ticket::Ticket::Ref t3(
    Dv::Ticket::Ticket::validate("localhost", 1050, 10000) );
  if (t3)
    throw std::runtime_error("validate invalid serial succeeded!");
  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
return 0;
}
