// $Id: test-ticket-client-special.C,v 1.2 2003/07/20 12:12:43 dvermeir Exp $

// Test ticketserver by sending test-request.xml to server.

#include <dvssl/sslsocket.h>
#include <dvssl/x509cert.h>
#include <dvxml/xml.h>
#include "ticket.h"

#include "xml-sndrcv.h"

int
main(int argc,char* argv[]) {

try {
  std::string local_host(Dv::Net::InetAddress::local_host());
  // std::cout << "local_host=" << local_host << std::endl;
  std::string dot_address(Dv::Net::InetAddress::by_name(local_host)->dot_address());
  // std::cout << "dot_address=" << dot_address << std::endl;

  std::cout << "1) Buy new ticket" << std::endl;

  Dv::Ticket::Ticket::Ref t1(
    Dv::Ticket::Ticket::buy("localhost", "localhost", 1050, "dvermeir", "abcdef1", "INFO") );
  if (! t1)
    throw std::runtime_error("cannot buy ticket");

  std::cout << t1->xml() << std::endl;

  std::cout << "2) Validate the ticket" << std::endl;
  Dv::Ticket::Ticket::Ref t2(
    Dv::Ticket::Ticket::validate("localhost", 1050, t1->serial()) );
  if (! t2)
    throw std::runtime_error("cannot validate ticket");
  std::cout << t2->xml() << std::endl;

  }
catch (std::exception& e) {
  std::cerr << e.what() << std::endl;
  return 1;
  }
return 0;
}
